/*

     Guaranteed cost H2 output feedback control problem
     Cross Decomposition algorithm - step YL

*/
clear lmi lme var

var sym Q(n) S(n,n) sym Y(n) L(m,n) sym W(size(B1'*B1))

N = size(Ax,1) / size(Ax,2);
n = size(Ax,2);
m = size(B2x,2);
p = size(C2x,1) / N;

Gg = Xk \ Fk;

Akx = zeros(size(Ax));
for i = 1:N
  Akx((i-1)*n+1:i*n,:) = Ax((i-1)*n+1:i*n,:) + Gg * C2x((i-1)*p+1:i*p,:);
end
Bk = B1 + Gg * D21;

lmi = block( Y; 
             Q    Q;
             B1'  Bk' W );

for i = 1:N
  lmi = block( -sym(Ax((i-1)*n+1:i*n,:)*Y+B2x((i-1)*n+1:i*n,:)*L);
               - ( Q*Ax((i-1)*n+1:i*n,:)'+...
                  Akx((i-1)*n+1:i*n,:)*Y+ ...
                  B2x((i-1)*n+1:i*n,:)*L+S' ),...
                 -sym(Akx((i-1)*n+1:i*n,:)*Q);
               -( C1*Y+D12*L ), -C1*Q, eye(size(C1*C1')) );
end

obj = trace(W);

