echo on
format compact
display = 5;

clear
A = [-2 1 1 1; 3 0 0 2; -1 0 -2 -3; -2 -1 2 -1];
B1 = [1 0 0; 0 0 0; 1 0 0; 0 0 0];
B2 = [0 0; 1 0; 0 0; 0 1];
C1 = [1 0 -1 0; 0 0 0 0; 0 0 0 0];
C2 = [1 0 0 0; 0 0 1 0];
D12 = [0 0; 1 0; 0 1];
D21 = [0 1 0; 0 0 1];
n = size(A,1);
m = size(B2,2);
p = size(C2,1);
eps = 1e-4;

B20 = [0 0; 1 0; 0 0; 0 1];
B21 = [0 0; 0 0; 0 0; 0 1];
B22 = [0 0; 1 0; 0 0; 0 0];

C20 = [1 0 0 0; 0 0 1 0];
C21 = [0 0 0 0; 0 0 1 0];
C22 = [1 0 0 0; 0 0 0 0];

Ax = [A; A; A; A; A];
B2x = [B20; B21; B22; B20; B20];
C2x = [C20; C20; C20; C21; C22];


exec ph2init

solve

Yk = Y; Lk = L;

prec = 1e-2;
while 1
	exec ph2XF, solve

	Xk = X; Fk = F;
	f1 = eval(obj)

	exec ph2YL, solve

	Yk = Y; Lk = L;
	f2 = eval(obj)

	if ( (f1 - f2)/f2 < prec )
		break;
	end
end

