/*
  Build H2 output feedback initialization problem
*/
clear lmi lme var

var sym X(n) F(n,p) sym Y(n) L(m,n) sym W(size(B1'*B1))

lmi = block( Y; 
             eye(n) X;
             B1'    B1'*X+D21'*F' W );

N = size(Ax,1) / size(Ax,2);
n = size(Ax,2);
m = size(B2x,2);
p = size(C2x,1) / N;

for i = 1:N
  lmi = block( -sym( Ax((i-1)*n+1:i*n,:)*Y+B2x((i-1)*n+1:i*n,:)*L );
               -(C1*Y+D12*L),  eye(size(C1*C1')) );
  lmi = block( -sym(X*Ax((i-1)*n+1:i*n,:)+F*C2x((i-1)*p+1:i*p,:) );
               -C1, eye(size(C1*C1')) );
end

obj = trace(W);

